package org.apache.jsp;

import javax.servlet.*;
import javax.servlet.http.*;
import javax.servlet.jsp.*;
import org.apache.jasper.runtime.*;
import java.util.*;
import java.text.*;
import java.sql.*;
import com.lavans.util.*;
import com.lavans.util.jdbc.*;

public class stats_jsp extends HttpJspBase {

 private String getHTTPDate() {
    java.text.SimpleDateFormat formatter =
      new java.text.SimpleDateFormat("E, dd MMM yyyy hh:mm:ss zzz", java.util.Locale.US);
    formatter.setTimeZone(java.util.TimeZone.getTimeZone("GMT"));
    return formatter.format(new java.util.Date());
  }


  private static java.util.Vector _jspx_includes;

  static {
    _jspx_includes = new java.util.Vector(1);
    _jspx_includes.add("/jsp/nocache.jsp");
  }

  public java.util.List getIncludes() {
    return _jspx_includes;
  }

  public void _jspService(HttpServletRequest request, HttpServletResponse response)
        throws java.io.IOException, ServletException {

    JspFactory _jspxFactory = null;
    javax.servlet.jsp.PageContext pageContext = null;
    HttpSession session = null;
    ServletContext application = null;
    ServletConfig config = null;
    JspWriter out = null;
    Object page = this;
    JspWriter _jspx_out = null;


    try {
      _jspxFactory = JspFactory.getDefaultFactory();
      response.setContentType("text/html; charset=windows-31j");
      pageContext = _jspxFactory.getPageContext(this, request, response,
      			null, true, 8192, true);
      application = pageContext.getServletContext();
      config = pageContext.getServletConfig();
      session = pageContext.getSession();
      out = pageContext.getOut();
      _jspx_out = out;

      out.write("<!-- $Id: stats.jsp,v 1.4 2004/08/24 11:41:29 yuk Exp $ -->\r\n");
      out.write("<!doctype html public \"-//w3c//dtd html 4.0 transitional//en\"\r\n   \"http://www.w3.org/tr/rec-html40/loose.dtd\">\r\n");
      out.write("\r\n\r\n");
      out.write("\r\n");
      out.write("\r\n");

  response.setHeader("Expires", getHTTPDate());
  response.setHeader("Pragma","no-cache");
  response.setHeader("Cache-Control","no-cache");

      out.write("\r\n");
      out.write("\r\n");
      out.write("\r\n");
      out.write("\r\n");
      out.write("\r\n");
      out.write("\r\n");
      out.write("\r\n");

	Logger logger = Logger.getInstance();
	logger.entering();
	
	logger.debug("0");
	BindConnection con = DBManager.getConnection();
	logger.debug("1");
	String sql = "select customer_id from customer where customer_id=:id and customer_name=:name";
	BindPreparedStatement st = con.bindPrepareStatement(sql);
	
	Statement st2 = con.createStatement();
	
	logger.debug("2");

	try{
	logger.debug("3");
		st.setString("id","001");
		st.setString("name","001name");
	logger.debug("4");
		ResultSet rs = st.executeQuery();
	logger.debug("5");
		if(rs.next()){
			logger.debug(rs.getString(1));
		}
		
		ResultSet rs2 = st2.executeQuery("select customer_name from customer");
		if(rs2.next()){
			logger.debug(rs2.getString(1));
		}
		
		
	}catch (Exception e) {
		logger.err(e);
	}finally{
		try{
			DBManager.releaseConnection(con);
		}catch (Exception e2) {
		
			// XXX: handle exception
		}
	}
	java.util.logging.Logger lo = java.util.logging.Logger.getLogger("test");
	long start = System.currentTimeMillis();
	for(int i=0;i<10000; i++){
		lo.info("loggertest");
	}
	long loggingtime = System.currentTimeMillis()-start;

	start = System.currentTimeMillis();
	for(int i=0;i<10000; i++){
		logger.debug("loggertest");
	}
	long loggertime = System.currentTimeMillis()-start;
	logger.debug("logging:"+ loggingtime +", logger:"+loggertime);
	
	logger.debug("6");
		
	Statistics stat = Statistics.getInstance();
	
	NumberFormat nf  = NumberFormat.getInstance();
	DecimalFormat df = new DecimalFormat("#,###.00");

      out.write("\r\n");
      out.write("<html lang=\"ja\">\r\n");
      out.write("<head>\r\n");
      out.write("<title>統計情報");
      out.write("</title>\r\n");
      out.write("<meta http-equiv=\"Content-Type\" content=\"text/html; charset=windows-31j\">\r\n");
      out.write("</head>\r\n");
      out.write("<body>\r\n\r\n\r\n");
      out.write("<table border=1 cellspacing=0 cellpadding=3>\r\n");
      out.write("<tr>\r\n  ");
      out.write("<th width=\"100\">SQL");
      out.write("</th>\r\n  ");
      out.write("<th width=\"100\">呼出元");
      out.write("</th>\r\n  ");
      out.write("<th width=\"100\">実行回数");
      out.write("</th>\r\n  ");
      out.write("<th width=\"100\">総実行時間(msec)");
      out.write("</th>\r\n  ");
      out.write("<th>平均実行時間(msec)");
      out.write("</th>\r\n");
      out.write("</tr>\r\n");

	List list = stat.getStatInfoByTotal();
	for(int i=0; i<list.size(); i++){
		StatsRecord rec = (StatsRecord)list.get(i);
		// 呼出元一覧
  		StringBuffer buf = new StringBuffer();
  		Object methods[] = rec.getMethodNames().toArray();
		for(int j=0; j<methods.length; j++){
			buf.append(methods[j] + "<br>");
		}

      out.write("\r\n");
      out.write("<tr>\r\n  ");
      out.write("<td>");
      out.print( rec.getSql().substring(0,30) );
      out.write("</td>\r\n  ");
      out.write("<td>");
      out.print( buf.toString() );
      out.write("</td>\r\n  ");
      out.write("<td align=\"right\">");
      out.print( nf.format(rec.getCallCount()) );
      out.write("</td>\r\n  ");
      out.write("<td align=\"right\">");
      out.print( nf.format(rec.getTotalCostTime()) );
      out.write("</td>\r\n  ");
      out.write("<td align=\"right\">");
      out.print( df.format(rec.getAverage()) );
      out.write("</td>\r\n");
      out.write("</tr>\r\n");

	}

      out.write("\r\n");
      out.write("</table>\r\n");

	logger.exiting();

      out.write("\r\n");
      out.write("</body>\r\n");
      out.write("</html>");
    } catch (Throwable t) {
      out = _jspx_out;
      if (out != null && out.getBufferSize() != 0)
        out.clearBuffer();
      if (pageContext != null) pageContext.handlePageException(t);
    } finally {
      if (_jspxFactory != null) _jspxFactory.releasePageContext(pageContext);
    }
  }
}
